Index: TWiki.pm
===================================================================
--- TWiki.pm	(revision 13172)
+++ TWiki.pm	(working copy)
@@ -68,7 +68,6 @@
             $VERSION $RELEASE
             $TRUE
             $FALSE
-            $sharedSandbox
            );
 
 # Token character that must not occur in any normal text - converted
@@ -137,6 +136,11 @@
     return $twikiLibDir;
 }
 
+# these vars are specifically designed to be overridden using local
+# for execution in sub-contexts.
+use vars qw( $SESSION $PREFS $SESSION $SANDBOX $PLUGINS $NET $STORE $SEARCH
+             $TEMPLATES $ATTACH $LOGIN $USERS $ACCESS $I18N );
+
 BEGIN {
 
     use TWiki::Sandbox;   # system command sandbox
@@ -447,10 +451,6 @@
 
     # initialize lib directory early because of later 'cd's
     getTWikiLibDir();
-
-    # "shared" between mod_perl instances
-    $sharedSandbox = new TWiki::Sandbox(
-        $TWiki::cfg{OS}, $TWiki::cfg{DetailedOS} );
 };
 
 use TWiki::Access;    # access control
@@ -657,7 +657,7 @@
 
     # DEPRECATED plugins header handler. Plugins should use
     # modifyHeaderHandler instead.
-    $pluginHeaders = $this->{plugins}->writeHeaderHandler( $query ) || '';
+    $pluginHeaders = $TWiki::PLUGINS->writeHeaderHandler( $query ) || '';
     if( $pluginHeaders ) {
         foreach ( split /\r\n/, $pluginHeaders ) {
             if ( m/^([\-a-z]+): (.*)$/i ) {
@@ -675,10 +675,10 @@
     $hopts->{'Content-Type'} = $contentType;
 
     # New (since 1.026)
-    $this->{plugins}->modifyHeaderHandler( $hopts, $this->{cgiQuery} );
+    $TWiki::PLUGINS->modifyHeaderHandler( $hopts, $this->{cgiQuery} );
 
     # add cookie(s)
-    $this->{loginManager}->modifyHeader( $hopts );
+    $TWiki::LOGIN->modifyHeader( $hopts );
 
     my $hdr = CGI::header( $hopts );
 
@@ -691,7 +691,7 @@
 
 Redirects the request to =$url=, *unless*
    1 It is overridden by a plugin declaring a =redirectCgiQueryHandler=.
-   1 =$session->{cgiQuery}= is =undef= or
+   1 =$TWiki::SESSION->{cgiQuery}= is =undef= or
    1 $query->param('noredirect') is set to a true value.
 Thus a redirect is only generated when in a CGI context.
 
@@ -748,8 +748,8 @@
         }
     }
 
-    return if( $this->{plugins}->redirectCgiQueryHandler( $query, $url ) );
-    return if( $this->{loginManager}->redirectCgiQuery( $query, $url ) );
+    return if( $TWiki::PLUGINS->redirectCgiQueryHandler( $query, $url ) );
+    return if( $TWiki::LOGIN->redirectCgiQuery( $query, $url ) );
     die "Login manager returned 0 from redirectCgiQuery";
 }
 
@@ -780,7 +780,7 @@
     $md5->add($$, time(), rand(time));
     my $uid = $md5->hexdigest();
     my $passthruFilename = $TWiki::cfg{TempfileDir} . '/passthru_' . $uid;
-    
+
     unless ( -d $TWiki::cfg{TempfileDir} ) {
         unless ( mkdir($TWiki::cfg{TempfileDir}) ) {
             die "Could not create $TWiki::cfg{TempfileDir} for passthrough files";
@@ -869,18 +869,18 @@
     my @mirrorInfo = ( '', '', '', '' );
     if( $TWiki::cfg{SiteWebTopicName} ) {
         my $mirrorSiteName =
-          $this->{prefs}->getWebPreferencesValue( 'MIRRORSITENAME', $theWeb );
+          $TWiki::PREFS->getWebPreferencesValue( 'MIRRORSITENAME', $theWeb );
         if( $mirrorSiteName && $mirrorSiteName ne $TWiki::cfg{SiteWebTopicName} ) {
             my $mirrorViewURL  =
-              $this->{prefs}->getWebPreferencesValue( 'MIRRORVIEWURL', $theWeb );
-            my $mirrorLink = $this->{templates}->readTemplate( 'mirrorlink' );
+              $TWiki::PREFS->getWebPreferencesValue( 'MIRRORVIEWURL', $theWeb );
+            my $mirrorLink = $TWiki::TEMPLATES->readTemplate( 'mirrorlink' );
             $mirrorLink =~ s/%MIRRORSITENAME%/$mirrorSiteName/g;
             $mirrorLink =~ s/%MIRRORVIEWURL%/$mirrorViewURL/g;
             $mirrorLink =~ s/\s*$//g;
-            my $mirrorNote = $this->{templates}->readTemplate( 'mirrornote' );
+            my $mirrorNote = $TWiki::TEMPLATES->readTemplate( 'mirrornote' );
             $mirrorNote =~ s/%MIRRORSITENAME%/$mirrorSiteName/g;
             $mirrorNote =~ s/%MIRRORVIEWURL%/$mirrorViewURL/g;
-            $mirrorNote = $this->{renderer}->getRenderedVersion
+            $mirrorNote = $TWiki::RENDER->getRenderedVersion
               ( $mirrorNote, $theWeb, $TWiki::cfg{HomeTopic} );
             $mirrorNote =~ s/\s*$//g;
             @mirrorInfo = ( $mirrorSiteName, $mirrorViewURL, $mirrorLink, $mirrorNote );
@@ -902,14 +902,14 @@
 
     ASSERT($this->isa( 'TWiki')) if DEBUG;
 
-    my $skinpath = $this->{prefs}->getPreferencesValue( 'SKIN' ) || '';
+    my $skinpath = $TWiki::PREFS->getPreferencesValue( 'SKIN' ) || '';
 
     if( $this->{cgiQuery} ) {
         my $resurface = $this->{cgiQuery}->param( 'skin' );
         $skinpath = $resurface if $resurface;
     }
 
-    my $epidermis = $this->{prefs}->getPreferencesValue( 'COVER' );
+    my $epidermis = $TWiki::PREFS->getPreferencesValue( 'COVER' );
     $skinpath = $epidermis.','.$skinpath if $epidermis;
 
     if( $this->{cgiQuery} ) {
@@ -1059,7 +1059,7 @@
 sub getIconUrl {
     my( $this, $absolute, $iconName ) = @_;
 
-    my $iconTopic = $this->{prefs}->getPreferencesValue( 'ICONTOPIC' );
+    my $iconTopic = $TWiki::PREFS->getPreferencesValue( 'ICONTOPIC' );
     my( $web, $topic) = $this->normalizeWebTopicName(
         $this->{webName}, $iconTopic );
     $iconName =~ s/^.*\.(.*?)$/$1/;
@@ -1082,12 +1082,12 @@
     my $fileExt = lc $bits[$#bits];
 
     unless( $this->{_ICONMAP} ) {
-        my $iconTopic = $this->{prefs}->getPreferencesValue( 'ICONTOPIC' );
+        my $iconTopic = $TWiki::PREFS->getPreferencesValue( 'ICONTOPIC' );
         my( $web, $topic) = $this->normalizeWebTopicName(
             $this->{webName}, $iconTopic );
         local $/ = undef;
         try {
-            my $icons = $this->{store}->getAttachmentStream(
+            my $icons = $TWiki::STORE->getAttachmentStream(
                 undef, $web, $topic, '_filetypes.txt' );
             %{$this->{_ICONMAP}} = split( /\s+/, <$icons> );
             close( $icons );
@@ -1236,19 +1236,28 @@
     $this->{htmlHeaders} = {};
     $this->{context} = $initialContext || {};
 
-    # create the various sub-objects
-    $this->{sandbox} = $sharedSandbox;
-    $this->{plugins} = new TWiki::Plugins( $this );
-    $this->{net} = new TWiki::Net( $this );
-    $this->{store} = new TWiki::Store( $this );
-    $this->{search} = new TWiki::Search( $this );
-    $this->{templates} = new TWiki::Templates( $this );
-    $this->{attach} = new TWiki::Attach( $this );
-    $this->{loginManager} = TWiki::Client::makeLoginManager( $this );
+    # Clear the session during initialisation so that we trap any attempts
+    # to use it during singleton creation
+    local $TWiki::SESSION = undef;
+
+    # create the various singletons, shared in this namespace
+    $TWiki::SANDBOX ||= new TWiki::Sandbox();
+    $TWiki::PLUGINS ||= new TWiki::Plugins();
+    $TWiki::NET ||= new TWiki::Net();
+    $TWiki::STORE ||= new TWiki::Store();
+    $TWiki::SEARCH ||= new TWiki::Search();
+    $TWiki::TEMPLATES ||= new TWiki::Templates();
+    $TWiki::ATTACH ||= new TWiki::Attach();
+
+    # OK, the session object is built up enough now that we can use it
+    local $TWiki::SESSION = $this;
+
+    $TWiki::LOGIN = TWiki::Client::makeLoginManager();
+
     # cache CGI information in the session object
     $this->{cgiQuery} = $query;
 
-    $this->{users} = new TWiki::Users( $this );
+    $TWiki::USERS ||= new TWiki::Users();
 
     # Make %ENV safer, preventing hijack of the search path
     # SMELL: can this be done in a BEGIN block? Or is the environment
@@ -1258,7 +1267,7 @@
     }
     delete @ENV{ qw( IFS CDPATH ENV BASH_ENV ) };
 
-    $this->{security} = new TWiki::Access( $this );
+    $TWiki::ACCESS = new TWiki::Access();
 
     my $web = '';
     my $topic = $query->param( 'topic' );
@@ -1370,14 +1379,13 @@
     # setup the cgi session, from a cookie or the url. this may return
     # the login, but even if it does, plugins will get the chance to override
     # it below.
-    my $login = $this->{remoteUser} = $this->{loginManager}->loadSession($loginName);
-    my $prefs = new TWiki::Prefs( $this );
-    $this->{prefs} = $prefs;
+    my $login = $this->{remoteUser} = $TWiki::LOGIN->loadSession($loginName);
+    $TWiki::PREFS = new TWiki::Prefs();
 
     # Push global preferences from TWiki.TWikiPreferences
-    $prefs->pushGlobalPreferences();
+    $TWiki::PREFS->pushGlobalPreferences();
 
-    my $plogin = $this->{plugins}->load( $TWiki::cfg{DisableAllPlugins} );
+    my $plogin = $TWiki::PLUGINS->load( $TWiki::cfg{DisableAllPlugins} );
     $login = $plogin if $plogin;
     $login ||= $TWiki::cfg{DefaultUserLogin};
     unless( $login =~ /$TWiki::cfg{LoginNameFilterIn}/) {
@@ -1385,7 +1393,7 @@
     }
     $login = TWiki::Sandbox::untaintUnchecked( $login );
 
-    my $user = $this->{users}->findUser( $login );
+    my $user = $TWiki::USERS->findUser( $login );
     $this->{user} = $user;
 
     # Static session variables that can be expanded in topics when they
@@ -1400,32 +1408,32 @@
     $this->{SESSION_TAGS}{INCLUDINGWEB}   = $this->{webName};
 
     # Push plugin settings
-    $this->{plugins}->settings();
+    $TWiki::PLUGINS->settings();
 
     # Now the rest of the preferences
-    $prefs->pushGlobalPreferencesSiteSpecific();
+    $TWiki::PREFS->pushGlobalPreferencesSiteSpecific();
 
-    $prefs->pushPreferences(
+    $TWiki::PREFS->pushPreferences(
         $TWiki::cfg{UsersWebName}, $user->wikiName(),
         'USER '.$user->wikiName() );
 
-    $prefs->pushWebPreferences( $this->{webName} );
+    $TWiki::PREFS->pushWebPreferences( $this->{webName} );
 
-    $prefs->pushPreferences(
+    $TWiki::PREFS->pushPreferences(
         $this->{webName}, $this->{topicName}, 'TOPIC' );
 
-    $prefs->pushPreferenceValues( 'SESSION',
-                                  $this->{loginManager}->getSessionValues() );
+    $TWiki::PREFS->pushPreferenceValues( 'SESSION',
+                                  $TWiki::LOGIN->getSessionValues() );
 
     # requires preferences (such as NEWTOPICBGCOLOR)
-    $this->{renderer} = new TWiki::Render( $this );
+    $TWiki::RENDER = new TWiki::Render( $this );
 
     # Finish plugin initialization - register handlers
-    $this->{plugins}->enable();
+    $TWiki::PLUGINS->enable();
 
     # language information; must be loaded after
     # *all possible preferences sources* are available
-    $this->{i18n} = TWiki::I18N::get( $this );
+    $TWiki::I18N = TWiki::I18N::get();
 
     return $this;
 }
@@ -1447,16 +1455,16 @@
 
 sub finish {
     my $this = shift;
-    $this->{loginManager}->finish();
+    $TWiki::LOGIN->finish();
 
 #    use Data::Dumper;
 #    $Data::Dumper::Indent = 1;
 #    warn "prepared to finish";
 #    warn Dumper($this);
 
-    $this->{prefs}->finish();
-    $this->{users}->finish();
-    $this->{store}->finish();
+    $TWiki::PREFS->finish();
+    $TWiki::USERS->finish();
+    $TWiki::STORE->finish();
 
     %$this = ();
  }
@@ -1656,19 +1664,19 @@
         my $incAtt = $3;
         # FIXME: Check for MIME type, not file suffix
         if( $incAtt =~ m/\.(txt|html?)$/i ) {
-            unless( $this->{store}->attachmentExists(
+            unless( $TWiki::STORE->attachmentExists(
                 $incWeb, $incTopic, $incAtt )) {
                 return $this->_includeWarning( $warn, 'bad_attachment', $url );
             }
             if( $incWeb ne $web || $incTopic ne $topic ) {
                 # CODE_SMELL: Does not account for not yet authenticated user
-                unless( $this->{security}->checkAccessPermission(
+                unless( $TWiki::ACCESS->checkAccessPermission(
                     'VIEW', $this->{user}, undef, undef, $incTopic, $incWeb ) ) {
                     return $this->_includeWarning( $warn, 'access_denied',
                                                    "$incWeb.$incTopic" );
                 }
             }
-            $text = $this->{store}->readAttachment( undef, $incWeb, $incTopic,
+            $text = $TWiki::STORE->readAttachment( undef, $incWeb, $incTopic,
                                                     $incAtt );
             $text = _cleanupIncludedHTML( $text, $this->{urlHost},
                                           $TWiki::cfg{PubUrlPath}, $options )
@@ -1691,7 +1699,7 @@
         return $text;
     }
 
-    my $response = $this->{net}->getExternalResource( $url );
+    my $response = $TWiki::NET->getExternalResource( $url );
     if( !$response->is_error()) {
         my $contentType = $response->header('content-type');
         $text = $response->content();
@@ -1761,14 +1769,14 @@
     $title = CGI::span( { class => 'twikiTocTitle' }, $title ) if( $title );
 
     if( $web ne $defaultWeb || $topic ne $defaultTopic ) {
-        unless( $this->{security}->checkAccessPermission
+        unless( $TWiki::ACCESS->checkAccessPermission
                 ( 'VIEW', $this->{user}, undef, undef, $topic, $web ) ) {
             return $this->inlineAlert( 'alerts', 'access_denied',
                                        $web, $topic );
         }
         my $meta;
         ( $meta, $text ) =
-          $this->{store}->readTopic( $this->{user}, $web, $topic );
+          $TWiki::STORE->readTopic( $this->{user}, $web, $topic );
     }
 
     my $insidePre = 0;
@@ -1776,9 +1784,9 @@
     my $highest = 99;
     my $result  = '';
     my $verbatim = {};
-    $text = $this->{renderer}->takeOutBlocks( $text, 'verbatim',
+    $text = $TWiki::RENDER->takeOutBlocks( $text, 'verbatim',
                                                $verbatim);
-    $text = $this->{renderer}->takeOutBlocks( $text, 'pre',
+    $text = $TWiki::RENDER->takeOutBlocks( $text, 'pre',
                                                $verbatim);
 
     # Find URL parameters
@@ -1809,7 +1817,7 @@
             # cut TOC exclude '---+ heading !! exclude this bit'
             $line =~ s/\s*$regex{headerPatternNoTOC}.+$//go;
             next unless $line;
-            my $anchor = $this->{renderer}->makeAnchorName( $line );
+            my $anchor = $TWiki::RENDER->makeAnchorName( $line );
             $highest = $level if( $level < $highest );
             my $tabs = "\t" x $level;
             # Remove *bold*, _italic_ and =fixed= formatting
@@ -1860,10 +1868,10 @@
     my $template = shift;
     my $def = shift;
 
-    my $text = $this->{templates}->readTemplate( 'oops'.$template,
+    my $text = $TWiki::TEMPLATES->readTemplate( 'oops'.$template,
                                                  $this->getSkin() );
     if( $text ) {
-        my $blah = $this->{templates}->expandTemplate( $def );
+        my $blah = $TWiki::TEMPLATES->expandTemplate( $def );
         $text =~ s/%INSTANTIATE%/$blah/;
         # web and topic can be anything; they are not used
         $text = $this->handleCommonTags( $text, $this->{webName},
@@ -2262,7 +2270,7 @@
     }
 
     my $verbatim = {};
-    $text = $this->{renderer}->takeOutBlocks( $text, 'verbatim',
+    $text = $TWiki::RENDER->takeOutBlocks( $text, 'verbatim',
                                                $verbatim);
 
     # See Item1442
@@ -2357,7 +2365,7 @@
 
     #$stackTop =~ s/$percent/%/go;
 
-    $this->{renderer}->putBackBlocks( \$stackTop, $verbatim, 'verbatim' );
+    $TWiki::RENDER->putBackBlocks( \$stackTop, $verbatim, 'verbatim' );
 
     #print STDERR "FINAL $stackTop\n" if $tell;
 
@@ -2375,7 +2383,7 @@
     my $args = shift;
     # my( $topic, $web ) = @_;
 
-    my $e = $this->{prefs}->getPreferencesValue( $tag );
+    my $e = $TWiki::PREFS->getPreferencesValue( $tag );
     unless( defined( $e )) {
         $e = $this->{SESSION_TAGS}{$tag};
         unless( defined( $e )) {
@@ -2434,7 +2442,7 @@
 relevant when rendering.
 
 Contexts are intended for use mainly by plugins. Core modules can
-use $session->inContext( $id ) to determine if a context is active.
+use $TWiki::SESSION->inContext( $id ) to determine if a context is active.
 
 =cut
 
@@ -2567,12 +2575,12 @@
     return $text unless $text;
     my $verbatim={};
     # Plugin Hook (for cache Plugins only)
-    $this->{plugins}->beforeCommonTagsHandler(
+    $TWiki::PLUGINS->beforeCommonTagsHandler(
         $text, $theTopic, $theWeb, $meta );
 
     #use a "global var", so included topics can extract and putback 
     #their verbatim blocks safetly.
-    $text = $this->{renderer}->takeOutBlocks( $text, 'verbatim',
+    $text = $TWiki::RENDER->takeOutBlocks( $text, 'verbatim',
                                               $verbatim);
 
     my $memW = $this->{SESSION_TAGS}{INCLUDINGWEB};
@@ -2582,12 +2590,12 @@
 
     $this->_expandAllTags( \$text, $theTopic, $theWeb );
 
-    $text = $this->{renderer}->takeOutBlocks( $text, 'verbatim',
+    $text = $TWiki::RENDER->takeOutBlocks( $text, 'verbatim',
                                               $verbatim);
 
 
     # Plugin Hook
-    $this->{plugins}->commonTagsHandler( $text, $theTopic, $theWeb, 0, $meta );
+    $TWiki::PLUGINS->commonTagsHandler( $text, $theTopic, $theWeb, 0, $meta );
 
     # process tags again because plugin hook may have added more in
     $this->_expandAllTags( \$text, $theTopic, $theWeb );
@@ -2605,10 +2613,10 @@
     # table rows properly
     $text =~ s/^<nop>\r?\n//gm;
 
-    $this->{renderer}->putBackBlocks( \$text, $verbatim, 'verbatim' );
+    $TWiki::RENDER->putBackBlocks( \$text, $verbatim, 'verbatim' );
 
     # TWiki Plugin Hook (for cache Plugins only)
-    $this->{plugins}->afterCommonTagsHandler(
+    $TWiki::PLUGINS->afterCommonTagsHandler(
         $text, $theTopic, $theWeb, $meta );
 
     return $text;
@@ -2709,12 +2717,12 @@
     my $cgiQuery = $this->{cgiQuery};
     my $cgiRev = $cgiQuery->param('rev') if( $cgiQuery );
     $params->{rev} = $cgiRev;
-    return $this->{renderer}->renderFORMFIELD( $params, $topic, $web );
+    return $TWiki::RENDER->renderFORMFIELD( $params, $topic, $web );
 }
 
 sub _TMPLP {
     my( $this, $params ) = @_;
-    return $this->{templates}->tmplP( $params );
+    return $TWiki::TEMPLATES->tmplP( $params );
 }
 
 sub _VAR {
@@ -2724,12 +2732,12 @@
     # handle %MAINWEB%-type cases
     ( $web, $topic ) = $this->normalizeWebTopicName( $web, $topic );
     # always return a value, even when the key isn't defined
-    return $this->{prefs}->getWebPreferencesValue( $key, $web ) || '';
+    return $TWiki::PREFS->getWebPreferencesValue( $key, $web ) || '';
 }
 
 sub _PLUGINVERSION {
     my( $this, $params ) = @_;
-    $this->{plugins}->getPluginVersion( $params->{_DEFAULT} );
+    $TWiki::PLUGINS->getPluginVersion( $params->{_DEFAULT} );
 }
 
 my $ifFactory;
@@ -2795,7 +2803,7 @@
     my $section = $params->remove('section');
     my $raw = $params->remove('raw') || '';
     my $warn = $params->remove('warn')
-      || $this->{prefs}->getPreferencesValue( 'INCLUDEWARNING' );
+      || $TWiki::PREFS->getPreferencesValue( 'INCLUDEWARNING' );
 
     if( $path =~ /^https?\:/ ) {
         # include web page
@@ -2832,7 +2840,7 @@
       $this->normalizeWebTopicName($includingWeb, $includedTopic);
 
     # See Codev.FailedIncludeWarning for the history.
-    unless( $this->{store}->topicExists($includedWeb, $includedTopic)) {
+    unless( $TWiki::STORE->topicExists($includedWeb, $includedTopic)) {
         return $this->_includeWarning( $warn, 'topic_not_found',
                                        $includedWeb, $includedTopic );
     }
@@ -2849,7 +2857,7 @@
     }
 
     my %saveTags = %{$this->{SESSION_TAGS}};
-    my $prefsMark = $this->{prefs}->mark();
+    my $prefsMark = $TWiki::PREFS->mark();
 
     $this->{includes}->{$key} = 1;
     $this->{SESSION_TAGS}{INCLUDINGWEB} = $includingWeb;
@@ -2861,10 +2869,10 @@
     }
 
     ( $meta, $text ) =
-      $this->{store}->readTopic( undef, $includedWeb, $includedTopic,
+      $TWiki::STORE->readTopic( undef, $includedWeb, $includedTopic,
                                  $rev );
 
-    unless( $this->{security}->checkAccessPermission(
+    unless( $TWiki::ACCESS->checkAccessPermission(
         'VIEW', $this->{user}, $text, $meta, $includedTopic, $includedWeb )) {
         if( isTrue( $warn )) {
             return $this->inlineAlert( 'alerts', 'access_denied',
@@ -2906,7 +2914,7 @@
     $this->_expandAllTags( \$text, $includedTopic, $includedWeb );
 
     # 4th parameter tells plugin that its called for an included file
-    $this->{plugins}->commonTagsHandler( $text, $includedTopic,
+    $TWiki::PLUGINS->commonTagsHandler( $text, $includedTopic,
                                          $includedWeb, 1, $meta );
 
     # We have to expand tags again, because a plugin may have inserted additional
@@ -2924,9 +2932,9 @@
         # '[[TopicName][...]]' to '[[Web.TopicName][...]]'
         $text =~ s/\[\[([^\]]+)\]\[([^\]]+)\]\]/&_fixIncludeLink( $includedWeb, $1, $2 )/geo;
 
-	    unless( TWiki::isTrue( $this->{prefs}->getPreferencesValue('NOAUTOLINK')) ) {
+	    unless( TWiki::isTrue( $TWiki::PREFS->getPreferencesValue('NOAUTOLINK')) ) {
 	        # Handle WikiWords
-	        $text = $this->{renderer}->takeOutBlocks( $text, 'noautolink', $removed );
+	        $text = $TWiki::RENDER->takeOutBlocks( $text, 'noautolink', $removed );
 	    }
 
         # 'TopicName' to 'Web.TopicName'
@@ -2934,7 +2942,7 @@
         $text =~ s/(^|[\s(])($regex{wikiWordRegex})/$1$includedWeb\.$2/go;
         $text =~ s/(^|[\s(])$TranslationToken/$1/go;
 
-        $this->{renderer}->putBackBlocks( \$text, $removed, 'noautolink' );
+        $TWiki::RENDER->putBackBlocks( \$text, $removed, 'noautolink' );
     }
 
     # handle tags again because of plugin hook
@@ -2944,7 +2952,7 @@
     delete $this->{includes}->{$key};
     %{$this->{SESSION_TAGS}} = %saveTags;
 
-    $this->{prefs}->restore( $prefsMark );
+    $TWiki::PREFS->restore( $prefsMark );
     $text =~ s/^[\r\n]+/\n/;
     $text =~ s/[\r\n]+$/\n/;
 
@@ -3002,7 +3010,7 @@
 sub _METASEARCH {
     my( $this, $params ) = @_;
 
-    return $this->{store}->searchMetaData( $params );
+    return $TWiki::STORE->searchMetaData( $params );
 }
 
 sub _DATE {
@@ -3038,7 +3046,7 @@
     $cgiRev = $cgiQuery->param('rev') if( $cgiQuery );
     my $rev = $cgiRev || $params->{rev} || '';
 
-    return $this->{renderer}->renderRevisionInfo( $web, $topic, undef,
+    return $TWiki::RENDER->renderRevisionInfo( $web, $topic, undef,
                                                   $rev, $format );
 }
 
@@ -3078,9 +3086,9 @@
     $params->{baseweb} = $web;
     $params->{basetopic} = $topic;
     $params->{search} = $params->{_DEFAULT} if( $params->{_DEFAULT} );
-    $params->{type} = $this->{prefs}->getPreferencesValue( 'SEARCHVARDEFAULTTYPE' ) unless( $params->{type} );
+    $params->{type} = $TWiki::PREFS->getPreferencesValue( 'SEARCHVARDEFAULTTYPE' ) unless( $params->{type} );
 
-    my $s = $this->{search}->searchWeb( %$params );
+    my $s = $TWiki::SEARCH->searchWeb( %$params );
     return $s;
 }
 
@@ -3102,11 +3110,11 @@
     my @webslist = split( /,\s*/, $webs );
     foreach my $aweb ( @webslist ) {
         if( $aweb eq 'public' ) {
-            push( @list, $this->{store}->getListOfWebs( 'user,public,allowed' ) );
+            push( @list, $TWiki::STORE->getListOfWebs( 'user,public,allowed' ) );
         } elsif( $aweb eq 'webtemplate' ) {
-            push( @list, $this->{store}->getListOfWebs( 'template,allowed' ));
+            push( @list, $TWiki::STORE->getListOfWebs( 'template,allowed' ));
         } else{
-            push( @list, $aweb ) if( $this->{store}->webExists( $aweb ) );
+            push( @list, $aweb ) if( $TWiki::STORE->webExists( $aweb ) );
         }
     }
 
@@ -3143,10 +3151,10 @@
 
     return '' if
       $web ne $this->{webName} &&
-      $this->{prefs}->getWebPreferencesValue( 'NOSEARCHALL', $web );
+      $TWiki::PREFS->getWebPreferencesValue( 'NOSEARCHALL', $web );
 
     my @items;
-    foreach my $item ( $this->{store}->getTopicNames( $web ) ) {
+    foreach my $item ( $TWiki::STORE->getTopicNames( $web ) ) {
         my $line = $format;
         $line =~ s/\$web\b/$web/g;
         $line =~ s/\$name\b/$item/g;
@@ -3345,7 +3353,7 @@
 
 sub _LANGUAGE {
     my $this = shift;
-    return $this->{i18n}->language();
+    return $I18N->language();
 }
 
 sub _LANGUAGES {
@@ -3359,7 +3367,7 @@
     my $marker = $params->{marker} || 'selected="selected"';
 
     # $languages is a hash reference:
-    my $languages = $this->{i18n}->enabled_languages();
+    my $languages = $I18N->enabled_languages();
 
     my @tags = sort(keys(%{$languages}));
 
@@ -3409,7 +3417,7 @@
     }
 
     # do the magic:
-    my $result  =  $this->{i18n}->maketext($str, @args);
+    my $result  =  $I18N->maketext($str, @args);
 
     # replace accesskeys:
     $result =~ s#(^|[^&])&([a-zA-Z])#$1<span class='twikiAccessKey'>$2</span>#g;
@@ -3467,7 +3475,7 @@
 }
 
 sub _ALLVARIABLES {
-    return shift->{prefs}->stringify();
+    return $TWiki::PREFS->stringify();
 }
 
 sub _META {
@@ -3481,17 +3489,17 @@
 
     if( $option eq 'form' ) {
         # META:FORM and META:FIELD
-        return TWiki::Form::renderForDisplay( $this->{templates}, $meta );
+        return TWiki::Form::renderForDisplay( $TWiki::TEMPLATES, $meta );
     } elsif ( $option eq 'formfield' ) {
         # a formfield from within topic text
-        return $this->{renderer}->renderFormField( $meta, $params );
+        return $TWiki::RENDER->renderFormField( $meta, $params );
     } elsif( $option eq 'attachments' ) {
         # renders attachment tables
-        return $this->{attach}->renderMetaData( $web, $topic, $meta, $params );
+        return $TWiki::ATTACH->renderMetaData( $web, $topic, $meta, $params );
     } elsif( $option eq 'moved' ) {
-        return $this->{renderer}->renderMoved( $web, $topic, $meta, $params );
+        return $TWiki::RENDER->renderMoved( $web, $topic, $meta, $params );
     } elsif( $option eq 'parent' ) {
-        return $this->{renderer}->renderParent( $web, $topic, $meta, $params );
+        return $TWiki::RENDER->renderParent( $web, $topic, $meta, $params );
     }
 
     return '';
@@ -3511,7 +3519,7 @@
 # Shortcut to %TMPL:P{"sep"}%
 sub _SEP {
     my $this = shift;
-    return $this->{templates}->expandTemplate('sep');
+    return $TWiki::TEMPLATES->expandTemplate('sep');
 }
 
 #deprecated functionality, now implemented using %USERINFO%
@@ -3520,7 +3528,7 @@
     my ( $this, $params ) = @_;
     ASSERT($this->isa( 'TWiki')) if DEBUG;
 
-    $params->{format} = $this->{prefs}->getPreferencesValue( 'WIKINAME' ) ||
+    $params->{format} = $TWiki::PREFS->getPreferencesValue( 'WIKINAME' ) ||
       '$wikiname';
 
     return $this->_USERINFO($params);
@@ -3532,7 +3540,7 @@
     my ( $this, $params ) = @_;
     ASSERT($this->isa( 'TWiki')) if DEBUG;
 
-    $params->{format} = $this->{prefs}->getPreferencesValue( 'USERNAME' ) ||
+    $params->{format} = $TWiki::PREFS->getPreferencesValue( 'USERNAME' ) ||
       '$username';
 
     return $this->_USERINFO($params);
@@ -3545,7 +3553,7 @@
     ASSERT($this->isa( 'TWiki')) if DEBUG;
 
     $params->{format} =
-      $this->{prefs}->getPreferencesValue( 'WIKIUSERNAME' ) ||
+      $TWiki::PREFS->getPreferencesValue( 'WIKIUSERNAME' ) ||
         '$wikiusername';
 
     return $this->_USERINFO($params);
@@ -3557,7 +3565,7 @@
 
     my $user = $this->{user};
     if( $params->{_DEFAULT} ) {
-        $user = $this->{users}->findUser( $params->{_DEFAULT}, undef, 1 );
+        $user = $TWiki::USERS->findUser( $params->{_DEFAULT}, undef, 1 );
         return '' if !$user;
         return '' if( $TWiki::cfg{AntiSpam}{HideUserDetails} &&
                         !$this->{user}->isAdmin() &&
@@ -3595,7 +3603,7 @@
 sub _GROUPS {
     my ( $this, $params ) = @_;
 
-    my $groups = $this->{users}->eachGroup();
+    my $groups = $TWiki::USERS->eachGroup();
     my @table;
     while( $groups->hasNext() ) {
         my $group = $groups->next();
Index: TWiki/Prefs/PrefsCache.pm
===================================================================
--- TWiki/Prefs/PrefsCache.pm	(revision 13172)
+++ TWiki/Prefs/PrefsCache.pm	(working copy)
@@ -132,10 +132,9 @@
 
     $this->{SOURCE} = $web.'.'.$topic;
 
-    my $session = $this->{MANAGER}->{session};
-    if( $session->{store}->topicExists( $web, $topic )) {
+    if( $TWiki::STORE->topicExists( $web, $topic )) {
         my( $meta, $text ) =
-          $session->{store}->readTopic( undef, $web, $topic, undef );
+          $TWiki::STORE->readTopic( undef, $web, $topic, undef );
 
         $parser ||= new TWiki::Prefs::Parser();
         $parser->parseText( $text, $this, $keyPrefix );
@@ -164,10 +163,9 @@
 
     $this->{SOURCE} = $web.'.'.$topic;
 
-    my $session = $this->{MANAGER}->{session};
     unless( $meta ) {
-        $meta = new TWiki::Meta( $session, $web, $topic );
-        $session->{store}->extractMetaData( $meta, \$text );
+        $meta = new TWiki::Meta( $web, $topic );
+        $TWiki::STORE->extractMetaData( $meta, \$text );
     }
 
     my $parser = new TWiki::Prefs::Parser();
